%Obteno de Funes de Transferncia a partir de respostas
%temporais a perturbao degrau.

% Este programa principal depende do arquivo objetivo.m para funcionar

%Tempo do degrau:
tdegrau=100;
%Dimensao do degrau:
degrau=0.1;

%Carrega sries temporais:
tempo=S.time;
X=X.signals.values;
S=S.signals.values;

%Variavel Desvio:
% X 
% remove o estado estacionario:
X=X-1.4535;
% S
% remove o estado estacionario:
S=S-0.3507;

%Acha o elemento que representa o instante de aplicacao do pulso
elemento=find(tempo>(tdegrau-0.1) & tempo<(tdegrau+0.1));
elemento=elemento(1); 
%Apaga tudo que existe antes desse instante
tempo(1:elemento,:)=[];
S(1:elemento,:)=[];
X(1:elemento,:)=[];

%Corrige a escala de tempo:
tempo=tempo-tdegrau;





%Seleo do Modelo 
modelo = menu('Seleo do Modelo                            ',...
   '1a. Ordem com Tempo Morto (linha G - tabela 121)        ',...
   'Lead-Lag com Tempo Morto  (linha P - tabela 121)        ',...
   '2a. Ordem com Tempo Morto (linha Q - tabela 121)        ',...
   '1 Polo, 2 Zeros com Tempo Morto (linha K - tabela 121)  ',...
   '1a. Ordem (linha A - tabela 121)                        ',...
   'Integrador (linha E - tabela 121)                       ',...
   'Integrador com tempo morto (linha M tabela 121)         ',...
   'Linha O Tabela 121                                      ',...
   'Linha F Tabela 121                                      ',...
   'Linha B Tabela 121                                      ');

%Valor inicial para parmetros

if   modelo == 1
   Tau=input('Tau1 = ');
   Ganho=input('Ganho= ');
   Tmorto=input('Tempo Morto= ');
   X0=[Tau Ganho Tmorto];
   vlb=[0.01  -100  0]; %limite inferior para o parametro otimizado
   vub=100*ones(3,1);    %limite superior para o parametro otimizado
   
elseif modelo==2
   Tau1=input('Tau Avano = ');
   Tau2=input('Tau Atraso = ');
   Ganho=input('Ganho=');
   Tmorto=input('Tempo Morto=');
   X0=[Tau1   Tau2 Ganho Tmorto];
   vlb=[0.01  0.01  -100  0]; %limite inferior para o parametro otimizado
   vub=100*ones(4,1);%limite superior para o parametro otimizado
   
elseif modelo==3
   Tau1=input('Tau1 = ');
   Tau2=input('Tau2 = ');
   Ganho=input('Ganho=');
   Tmorto=input('Tempo Morto=');
   X0=[Tau1   Tau2   Ganho  Tmorto];
   vlb=[0.01  0.01   -100     0]; %limite inferior para o parametro otimizado
   vub=100*ones(4,1);%limite superior para o parametro otimizado
   
elseif modelo==4
   Tau1=input('Tau1 =        ');
   Tau2=input('Tau2 =        ');
   Tau3=input('Tau Avano = ');
   Ganho=input('Ganho=');
   Tmorto=input('Tempo Morto=');
   X0=[Tau1   Tau2   Tau3   Ganho Tmorto];
   vlb=[0.01  0.01   0.01    -100  0]; %limite inferior para o parametro otimizado
   vub=100*ones(5,1);%limite superior para o parametro otimizado
   
elseif modelo==5
   Tau=input('Tau  =        ');
   K  =input('K    =        ');
   X0= [Tau    K];
   vlb=[0.01  -100];%limite inferior para o parametro otimizado
   vub=100*ones(2,1);%limite superior para o parametro otimizado

elseif modelo==6
    K =input('K   =       ');
    X0=[K];
    vlb=[-100];%limite inferior para o parametro otimizado
    vub=100*ones(1,1);%limite superior para o parametro otimizado
    
    
elseif modelo==7
    K =input('K  =              ');
    Tmorto=input('Tempo Morto=  ');
    X0=[K      Tmorto];
    vlb=[-100    0];%limite inferior para o parametro otimizado
    vub=10000*ones(2,1);%limite superior para o parametro otimizado
 
    
elseif modelo==8
    K =input('K =              ');
    Tau=input('Tau=            ');
    Tmorto=input('Tempo Morto= ');
    X0=[K      Tau   Tmorto];
    vlb=[-100  0.01   0];%limite inferior para o parametro otimizado
    vub=100*ones(3,1);%limite superior para o parametro otimizado
 
    
elseif modelo==9
    K =input('K=      ');
    Tau=input('Tau=    ');
    X0=[K      Tau];
    vlb=[-100  0.01];%limite inferior para o parametro otimizado
    vub=100*ones(2,1);%limite superior para o parametro otimizado
 
    
else
    K= input('K=     ');
    Tau1=input('Tau1=  ');
    Tau2=input('Tau2=  ');
    X0=[K     Tau1   Tau2];
    vlb=[-100 0.01    0.01];%limite inferior para o parametro otimizado
    vub=100*ones(3,1);%limite superior para o parametro otimizado
     
end

%Ajusta a opao de visualizacao:
% OPTIONS(1)-Display parameter (Default:0). 1 displays some results.
opcao=foptions;
opcao(1)=1;

%Chama o otimizador:
y=S; %dados a serem ajustados
Xotimo=constr('objetivo',X0,opcao,vlb,vub,[],degrau,y,tempo,modelo)
